module RailsRequests
  class BaseReport
    def collect(group)
      keys   = RailsRequests.redis.keys("*#{Date.current.strftime("%Y%m%d")}*|*total_duration")
      values = RailsRequests.redis.mget(keys)

      @collection = RailsRequests::Collection.new

      keys.each_with_index do |key, index|
        @collection.data << RailsRequests::Record.new(key, values[index])
      end

      @collection.group_by(group).values.inject([]) do |res, (k,v)|
        res << yield(k, v)
        res
      end
    end
  end
end